Whamcloud - gitweb
LU-6124 test: skip tests require remote server with nodsh set
[fs/lustre-release.git] / lustre / tests / sanityn.sh
index 63321ae..9acd1cb 100644 (file)
@@ -3,23 +3,15 @@
 set -e
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test: 3192 LU-1205 15528/3811 16929 9977 15528/11549 18080
-ALWAYS_EXCEPT="                14b  18c     19         22    28   29          35    $SANITYN_EXCEPT"
+# bug number for skipped test: 3192 LU-1205 15528/3811 9977 15528/11549 18080
+ALWAYS_EXCEPT="                14b  18c     19         28   29          35    $SANITYN_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
-# bug number for skipped test:        12652 12652
-grep -q 'Enterprise Server 10' /etc/SuSE-release 2> /dev/null &&
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 11    14" || true
-
-# It will be ported soon.
-EXCEPT="$EXCEPT 22"
-
-SRCDIR=`dirname $0`
+SRCDIR=$(dirname $0)
 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
 
 SIZE=${SIZE:-40960}
 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
-MCREATE=${MCREATE:-mcreate}
 OPENFILE=${OPENFILE:-openfile}
 OPENUNLINK=${OPENUNLINK:-openunlink}
 export MULTIOP=${MULTIOP:-multiop}
@@ -40,9 +32,12 @@ init_test_env $@
 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
 init_logging
 
-[ $(facet_fstype $SINGLEMDS) = "zfs" ] &&
-# bug number for skipped test:        LU-2840 LU-2189 LU-2776
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 21      36      51a"
+if [ $(facet_fstype $SINGLEMDS) = "zfs" ]; then
+# bug number for skipped test:        LU-2189 LU-2776
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 36      51a"
+# LU-2829 / LU-2887 - make allowances for ZFS slowness
+       TEST33_NFILES=${TEST33_NFILES:-1000}
+fi
 
 [ "$SLOW" = "no" ] && EXCEPT_SLOW="33a"
 
@@ -169,6 +164,18 @@ test_2f() {
 }
 run_test 2f "check attr/owner updates on DNE with 2 mtpt's"
 
+test_2g() {
+       dd if=/dev/zero of=$DIR1/$tfile oflag=sync bs=1M count=2
+
+       local block1=$(stat $DIR1/$tfile | awk '/Blocks/ {print $4} ')
+       cancel_lru_locks osc
+       local block2=$(stat $DIR2/$tfile | awk '/Blocks/ {print $4} ')
+       echo "$DIR1/$tfile has $block1 blocks"
+       echo "$DIR2/$tfile has $block2 blocks"
+       [ $block1 -eq $block2 ] || error
+}
+run_test 2g "check blocks update on sync write"
+
 test_3() {
        local target="this/is/good"
        ln -s $target $DIR1/$tfile || error "ln -s $target $DIR1/$tfile failed"
@@ -489,7 +496,8 @@ test_21() { # Bug 5907
 run_test 21 " Try to remove mountpoint on another dir ===="
 
 test_23() { # Bug 5972
-       local at_diff=$(do_facet $SINGLEMDS $LCTL get_param -n mdd.*.atime_diff)
+       local at_diff=$(do_facet $SINGLEMDS \
+               $LCTL get_param -n mdd.*MDT0000*.atime_diff | head -n1)
        echo "atime should be updated while another read" > $DIR1/$tfile
 
        # clear the lock(mode: LCK_PW) gotten from creating operation
@@ -623,11 +631,11 @@ test_27() {
        DD2_PID=$!
        usleep 50
        log "dd 1 started"
-       
+
        dd if=/dev/zero of=$DIR1/$tfile bs=$((16384-1024))k conv=notrunc count=1 seek=4 &
        DD1_PID=$!
        log "dd 2 started"
-       
+
        sleep 1
        dd if=/dev/zero of=$DIR1/$tfile bs=8k conv=notrunc count=1 seek=0
        log "dd 3 finished"
@@ -639,7 +647,7 @@ run_test 27 "align non-overlapping extent locks from request ==="
 
 test_28() { # bug 9977
        ECHO_UUID="ECHO_osc1_UUID"
-       tOST=`$LCTL dl | | awk '/-osc-|OSC.*MNT/ { print $4 }' | head -1`
+       tOST=$($LCTL dl | awk '/-osc-|OSC.*MNT/ { print $4 }' | head -n1)
 
        $LFS setstripe $DIR1/$tfile -S 1048576 -i 0 -c 2
        tOBJID=`$LFS getstripe $DIR1/$tfile | awk '$1 == 1 {print $2}'`
@@ -754,14 +762,14 @@ test_32a() { # bug 11270
         log "checking cached lockless truncate"
         $TRUNCATE $DIR1/$tfile 8000000
         $CHECKSTAT -s 8000000 $DIR2/$tfile || error "wrong file size"
-        [ $(calc_osc_stats lockless_truncate) -eq 0 ] ||
-                error "lockless truncate doesn't use cached locks"
+       [ $(calc_osc_stats lockless_truncate) -ne 0 ] ||
+               error "cached truncate isn't lockless"
 
         log "checking not cached lockless truncate"
         $TRUNCATE $DIR2/$tfile 5000000
         $CHECKSTAT -s 5000000 $DIR1/$tfile || error "wrong file size"
-        [ $(calc_osc_stats lockless_truncate) -ne 0 ] ||
-                error "not cached trancate isn't lockless"
+       [ $(calc_osc_stats lockless_truncate) -ne 0 ] ||
+               error "not cached truncate isn't lockless"
 
         log "disabled lockless truncate"
         enable_lockless_truncate 0
@@ -834,8 +842,8 @@ print_jbd_stat () {
         varsvc=${mds}_svc
         dev=$(basename $(do_facet $mds "lctl get_param -n osd*.${!varsvc}.mntdev|\
                xargs readlink -f" ))
-        val=$(do_facet $mds "cat /proc/fs/jbd*/${dev}{,:*,-*}/info 2>/dev/null|\
-               head -1")
+       val=$(do_facet $mds "cat /proc/fs/jbd*/${dev}{,:*,-*}/info 2>/dev/null |
+               head -n1")
         val=${val%% *};
         stat=$(( stat + val))
     done
@@ -975,6 +983,7 @@ cleanup_34() {
 }
 
 test_34() { #16129
+       remote_ost_nodsh && skip "remote OST with nodsh" && return
         local OPER
         local lock_in
         local lock_out
@@ -1024,8 +1033,9 @@ run_test 34 "no lock timeout under IO"
 test_35() { # bug 17645
         local generation=[]
         local count=0
-        for imp in /proc/fs/lustre/mdc/$FSNAME-MDT*-mdc-*; do
-            g=$(awk '/generation/{print $2}' $imp/import)
+       gen=$(lctl get_param mdc.$FSNAME-MDT*-mdc-*.import | grep generation |
+               awk '/generation/{print $2}')
+       for g in $gen; do
             generation[count]=$g
             let count=count+1
         done
@@ -1067,10 +1077,20 @@ test_35() { # bug 17645
         do_facet client "lctl set_param fail_loc=0x0"
         df -h $MOUNT1 $MOUNT2
         count=0
-        for imp in /proc/fs/lustre/mdc/$FSNAME-MDT*-mdc-*; do
-            g=$(awk '/generation/{print $2}' $imp/import)
-            if ! test "$g" -eq "${generation[count]}"; then
-                error "Eviction happened on import $(basename $imp)"
+       gen=$(lctl get_param mdc.$FSNAME-MDT*-mdc-*.import | grep generation |
+               awk '/generation/{print $2}')
+       for g in $gen; do
+           if ! test "$g" -eq "${generation[count]}"; then
+               list=$(lctl list_param mdc.$FSNAME-MDT*-mdc-*.import)
+               local c = 0
+               for imp in $list; do
+                       if [ $c = $count ]; then
+                               break
+                       fi
+                       c=c+1
+               done
+               imp=$(echo "$imp" | awk -F"." '{print $2}')
+               error "Eviction happened on import $imp"
             fi
             let count=count+1
         done
@@ -1241,8 +1261,10 @@ check_pdo_conflict() {
 # pdirop tests
 # test 40: check non-blocking operations
 test_40a() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       touch $DIR2
        mkdir $DIR1/$tfile &
        PID1=$!
        sleep 1
@@ -1260,11 +1282,6 @@ test_40a() {
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
 
-       if [ $MDSCOUNT -ge 2 ]; then
-               $LFS mkdir -i 1 $DIR2/$tfile-6
-               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
-       fi
-
        # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
@@ -1274,6 +1291,7 @@ test_40a() {
 run_test 40a "pdirops: create vs others =============="
 
 test_40b() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
        touch $DIR1/$tfile &
@@ -1295,11 +1313,6 @@ test_40b() {
        check_pdo_conflict $PID1 || error "unlink is blocked"
        # all operations above shouldn't wait the first one
 
-       if [ $MDSCOUNT -ge 2 ]; then
-               $LFS mkdir -i 1 $DIR2/$tfile-6
-               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
-       fi
-
         check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
        rm -r $DIR1/*
@@ -1308,6 +1321,7 @@ test_40b() {
 run_test 40b "pdirops: open|create and others =============="
 
 test_40c() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
        touch $DIR1/$tfile
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
@@ -1329,11 +1343,6 @@ test_40c() {
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
 
-       if [ $MDSCOUNT -ge 2 ]; then
-               $LFS mkdir -i 1 $DIR2/$tfile-6
-               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
-       fi
-
         # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
@@ -1343,6 +1352,7 @@ test_40c() {
 run_test 40c "pdirops: link and others =============="
 
 test_40d() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
        touch $DIR1/$tfile
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
@@ -1364,11 +1374,6 @@ test_40d() {
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
 
-       if [ $MDSCOUNT -ge 2 ]; then
-               $LFS mkdir -i 1 $DIR2/$tfile-6
-               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
-       fi
-
        # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
@@ -1377,6 +1382,7 @@ test_40d() {
 run_test 40d "pdirops: unlink and others =============="
 
 test_40e() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
        touch $DIR1/$tfile
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
@@ -1396,11 +1402,6 @@ test_40e() {
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
 
-       if [ $MDSCOUNT -ge 2 ]; then
-               $LFS mkdir -i 1 $DIR2/$tfile-6
-               check_pdo_conflict $PID1 || error "remote mkdir is blocked"
-       fi
-
        # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
@@ -2328,29 +2329,216 @@ test_51b() {
 run_test 51b "layout lock: glimpse should be able to restart if layout changed"
 
 test_51c() {
-       # create an empty file
-       $MCREATE $DIR1/$tfile
+       [ $OSTCOUNT -ge 2 ] || { skip "need at least 2 osts"; return; }
+
+       # set default layout to have 1 stripe
+       mkdir -p $DIR1/$tdir
+       $LFS setstripe -c 1 $DIR1/$tdir
+
+       # create a file with empty layout
+       $MCREATE $DIR1/$tdir/$tfile
 
 #define OBD_FAIL_MDS_LL_BLOCK 0x172
-       $LCTL set_param fail_loc=0x172
+       do_facet $SINGLEMDS $LCTL set_param fail_loc=0x172
 
        # change the layout of testing file
-       echo "Setting layout ..."
-       $LFS setstripe -c $OSTCOUNT $DIR1/$tfile &
+       echo "Setting layout to have $OSTCOUNT stripes ..."
+       $LFS setstripe -c $OSTCOUNT $DIR1/$tdir/$tfile &
        pid=$!
        sleep 1
 
-       # get layout of this file should wait until dd is finished
-       local stripecnt=`$LFS getstripe -c $DIR2/$tfile`
-       [ $stripecnt -eq $OSTCOUNT ] || error "layout wrong"
+       # write something to the file, it should be blocked on fetching layout
+       dd if=/dev/zero of=$DIR2/$tdir/$tfile bs=1k count=1 conv=notrunc
+       local cnt=$($LFS getstripe -c $DIR2/$tdir/$tfile)
+       [ $cnt -eq $OSTCOUNT ] || error "have $cnt stripes, expected $OSTCOUNT"
 
-       rm -f $DIR1/$tfile
+       rm -fr $DIR1/$tdir
 }
 run_test 51c "layout lock: IT_LAYOUT blocked and correct layout can be returned"
 
+test_51d() {
+       dd if=/dev/zero of=/$DIR1/$tfile bs=1M count=1
+       cancel_lru_locks mdc
+
+       # open should grant LAYOUT lock, mmap and read will install pages
+       $MULTIOP $DIR1/$tfile oO_RDWR:SMR_Uc &
+       local PID=$!
+       sleep 1
+
+       # rss before revoking
+       local br=$(grep -A 10 $tfile /proc/$PID/smaps | awk '/^Rss/{print $2}')
+       echo "Before revoking layout lock: $br KB mapped"
+
+       # delete the file will revoke layout lock
+       rm -f $DIR2/$tfile
+
+       # rss after revoking
+       local ar=$(grep -A 10 $tfile /proc/$PID/smaps | awk '/^Rss/{print $2}')
+
+       kill -USR1 $PID
+       wait $PID || error
+
+       [ $ar -eq 0 ] || error "rss before: $br, after $ar, some pages remained"
+}
+run_test 51d "layout lock: losing layout lock should clean up memory map region"
+
+test_54_part1()
+{
+       echo "==> rename vs getattr vs setxattr should not deadlock"
+       mkdir -p $DIR/d1/d2/d3 || error "(1) mkdir failed"
+
+       do_facet mds $LCTL set_param fail_loc=$1
+
+       mv -T $DIR/d1/d2/d3 $DIR/d1/d3 &
+       PID1=$!
+       sleep 1
+
+       stat $DIR/d1/d2 &
+       PID2=$!
+       sleep 1
+
+       setfattr -n user.attr1 -v value1 $DIR2/d1 || error "(2) setfattr failed"
+       wait $PID1 || error "(3) mv failed"
+       wait $PID2 || error "(4) stat failed"
+       echo
+
+       rm -rf $DIR/d1
+}
+
+test_54_part2() {
+       echo "==> rename vs getattr vs open vs getattr should not deadlock"
+       mkdir -p $DIR/d1/d2/d3 || error "(1) mkdir failed"
+
+       do_facet mds $LCTL set_param fail_loc=$1
+
+       mv -T $DIR/d1/d2/d3 $DIR/d1/d3 &
+       PID1=$!
+       sleep 1
+
+       stat $DIR/d1/d2 &
+       PID2=$!
+       sleep 1
+
+       $MULTIOP $DIR2/d1/d2 Oc &
+       PID3=$!
+       sleep 1
+
+       stat $DIR/d1 || error "(2) stat failed"
+
+       wait $PID1 || error "(3) mv failed"
+       wait $PID2 || error "(4) stat failed"
+       wait $PID3 && error "(5) multiop failed"
+       echo
+       rm -rf $DIR/d1
+}
+
+test_54() {
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_lustre_params client "llite.*.xattr_cache" > $p
+       lctl set_param llite.*.xattr_cache 1 ||
+               { skip "xattr cache is not supported"; return 0; }
+
+#define OBD_FAIL_MDS_RENAME              0x153
+#define OBD_FAIL_MDS_RENAME2             0x154
+       test_54_part1 0x80000153 || error 10
+       test_54_part1 0x80000154 || error 11
+       test_54_part2 0x80000153 || error 12
+       test_54_part2 0x80000154 || error 13
+
+       restore_lustre_params < $p
+       rm -f $p
+}
+run_test 54 "rename locking"
+
+test_55a() {
+       mkdir -p $DIR/d1/d2 $DIR/d3 || error "(1) mkdir failed"
+
+#define OBD_FAIL_MDS_RENAME4              0x156
+       do_facet mds $LCTL set_param fail_loc=0x80000156
+
+       mv -T $DIR/d1/d2 $DIR/d3/d2 &
+       PID1=$!
+       sleep 1
+
+       rm -r $DIR2/d3
+       wait $PID1 && error "(2) mv succeeded"
+
+       rm -rf $DIR/d1
+}
+run_test 55a "rename vs unlink target dir"
+
+test_55b()
+{
+       mkdir -p $DIR/d1/d2 $DIR/d3 || error "(1) mkdir failed"
+
+#define OBD_FAIL_MDS_RENAME4             0x156
+       do_facet mds $LCTL set_param fail_loc=0x80000156
+
+       mv -T $DIR/d1/d2 $DIR/d3/d2 &
+       PID1=$!
+       sleep 1
+
+       rm -r $DIR2/d1
+       wait $PID1 && error "(2) mv succeeded"
+
+       rm -rf $DIR/d3
+}
+run_test 55b "rename vs unlink source dir"
+
+test_55c()
+{
+       mkdir -p $DIR/d1/d2 $DIR/d3 || error "(1) mkdir failed"
+
+#define OBD_FAIL_MDS_RENAME4              0x156
+       do_facet mds $LCTL set_param fail_loc=0x156
+
+       mv -T $DIR/d1/d2 $DIR/d3/d2 &
+       PID1=$!
+       sleep 1
+
+       # while rename is sleeping, open and remove d3
+       $MULTIOP $DIR2/d3 D_c &
+       PID2=$!
+       sleep 1
+       rm -rf $DIR2/d3
+       sleep 5
+
+       # while rename is sleeping 2nd time, close d3
+       kill -USR1 $PID2
+       wait $PID2 || error "(3) multiop failed"
+
+       wait $PID1 && error "(2) mv succeeded"
+
+       rm -rf $DIR/d1
+}
+run_test 55c "rename vs unlink orphan target dir"
+
+test_55d()
+{
+       touch $DIR/f1
+
+#define OBD_FAIL_MDS_RENAME3              0x155
+       do_facet mds $LCTL set_param fail_loc=0x155
+       mv $DIR/f1 $DIR/$tdir &
+       PID1=$!
+       sleep 2
+
+       # while rename is sleeping, create $tdir, but as a directory
+       mkdir -p $DIR2/$tdir || error "(1) mkdir failed"
+
+       # link in reverse locking order
+       ln $DIR2/f1 $DIR2/$tdir/
+
+       wait $PID1 && error "(2) mv succeeded"
+       rm -rf $DIR/f1
+}
+run_test 55d "rename file vs link"
+
 test_60() {
-       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.0) ]] ||
-       { skip "Need MDS version at least 2.3.0"; return; }
+       local MDSVER=$(lustre_build_version $SINGLEMDS)
+       [ $(version_code $MDSVER) -lt $(version_code 2.3.0) ] &&
+               skip "MDS version $MDSVER must be >= 2.3.0" && return 0
+
        # Create a file
        test_mkdir -p $DIR1/$tdir
        file1=$DIR1/$tdir/file
@@ -2479,6 +2667,8 @@ run_test 71 "correct file map just after write operation is finished"
 
 test_72() {
        local p="$TMP/sanityN-$TESTNAME.parameters"
+       local tlink1
+       local tlink2
        save_lustre_params client "llite.*.xattr_cache" > $p
        lctl set_param llite.*.xattr_cache 1 ||
                { skip "xattr cache is not supported"; return 0; }
@@ -2492,6 +2682,14 @@ test_72() {
                error "setfattr2 failed"
        getfattr -n user.attr1 $DIR1/$tfile | grep value2 ||
                error "getfattr2 failed"
+
+       # check that trusted.link is consistent
+       tlink1=$(getfattr -n trusted.link $DIR1/$tfile | md5sum)
+       ln $DIR2/$tfile $DIR2/$tfile-2 || error "failed to link"
+       tlink2=$(getfattr -n trusted.link $DIR1/$tfile | md5sum)
+       echo "$tlink1 $tlink2"
+       [ "$tlink1" = "$tlink2" ] && error "trusted.link should have changed!"
+
        rm -f $DIR2/$tfile
 
        restore_lustre_params < $p
@@ -2526,16 +2724,495 @@ test_73() {
 run_test 73 "getxattr should not cause xattr lock cancellation"
 
 test_74() {
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.4.93) ] &&
+               skip "Need MDS version at least 2.4.93" && return
+
        dd if=/dev/zero of=$DIR1/$tfile-1 bs=1K count=1
        dd if=/dev/zero of=$DIR1/$tfile-2 bs=1K count=1
        flocks_test 4 $DIR1/$tfile-1 $DIR2/$tfile-2
 }
 run_test 74 "flock deadlock: different mounts =============="
 
+# LU-3889
+test_75() {
+       $LFS setstripe -c 2 -S 1m -i 0 $DIR1/$tfile
+       dd if=/dev/zero of=$DIR1/$tfile bs=1M count=2
+       cancel_lru_locks osc
+
+       dd of=$DIR1/$tfile if=/dev/zero bs=1M count=1 seek=1 conv=notrunc
+       sync
+
+       # define OBD_FAIL_LDLM_ENQUEUE_HANG 0x31d
+       $LCTL set_param fail_loc=0x31d
+       stat -c %s $DIR1/$tfile &
+       local pid=$!
+       sleep 1
+       kill -9 $pid
+
+       # For bad lock error handler we should ASSERT and got kernel panic here
+       sleep 4
+       $LCTL set_param fail_loc=0
+}
+run_test 75 "osc: upcall after unuse lock==================="
+
+test_76() { #LU-946
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.5.53) ]] &&
+               skip "Need MDS version at least 2.5.53" && return
+
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       local fcount=2048
+       declare -a fd_list
+       declare -a fid_list
+
+       if remote_mds; then
+               nid=$($LCTL list_nids | sed  "s/\./\\\./g")
+       else
+               nid="0@lo"
+       fi
+
+       rm -rf $DIR/$tdir
+       test_mkdir -p $DIR/$tdir
+
+       # drop all open locks and close any cached "open" files on the client
+       cancel_lru_locks mdc
+
+       echo -n "open files "
+       ulimit -n 8096
+       for ((i = 0; i < $fcount; i++)); do
+               touch $DIR/$tdir/f_$i
+               local fd=$(free_fd)
+               local cmd="exec $fd<$DIR/$tdir/f_$i"
+               eval $cmd
+               fd_list[i]=$fd
+               echo -n "."
+       done
+       echo
+
+       local get_open_fids="$LCTL get_param -n mdt.*.exports.'$nid'.open_files"
+       local fid_list=($(do_nodes $(comma_list $(mdts_nodes)) $get_open_fids))
+
+       # Possible errors in openfiles FID list.
+       # 1. Missing FIDs. Check 1
+       # 2. Extra FIDs. Check 1
+       # 3. Duplicated FID. Check 2
+       # 4. Invalid FIDs. Check 2
+       # 5. Valid FID, points to some other file. Check 3
+
+       # Check 1
+       [ ${#fid_list[@]} -ne $fcount ] &&
+               error "${#fid_list[@]} != $fcount open files"
+
+       for (( i = 0; i < $fcount; i++ )) ; do
+               cmd="exec ${fd_list[i]}</dev/null"
+               eval $cmd
+               filename=$($LFS fid2path $DIR2 ${fid_list[i]})
+
+               # Check 2
+               rm --interactive=no $filename
+               [ $? -ne 0 ] &&
+                       error "Nonexisting fid ${fid_list[i]} listed."
+       done
+
+       # Check 3
+       ls_op=$(ls $DIR2/$tdir | wc -l)
+       [ $ls_op -ne 0 ] &&
+               error "Some openfiles are missing in lproc output"
+
+       rm -rf $DIR/$tdir
+}
+run_test 76 "Verify open file for 2048 files"
+
+nrs_write_read() {
+       local n=16
+       local dir=$DIR/$tdir
+       local myRUNAS="$1"
+
+       mkdir $dir || error "mkdir $dir failed"
+       $LFS setstripe -c $OSTCOUNT $dir || error "setstripe to $dir failed"
+       chmod 777 $dir
+
+       do_nodes $CLIENTS $myRUNAS dd if=/dev/zero of="$dir/nrs_r_$HOSTNAME"\
+               bs=1M count=$n > /dev/null 2>&1
+
+       for ((i = 0; i < $n; i++)); do
+               do_nodes $CLIENTS $myRUNAS dd if=/dev/zero\
+                       of="$dir/nrs_w_$HOSTNAME" bs=1M seek=$i count=1\
+                        > /dev/null 2>&1 &
+               local pids_w[$i]=$!
+       done
+       do_nodes $CLIENTS sync;
+       cancel_lru_locks osc
+
+       for ((i = 0; i < $n; i++)); do
+               do_nodes $CLIENTS $myRUNAS dd if="$dir/nrs_w_$HOSTNAME"\
+                       of=/dev/zero bs=1M seek=$i count=1 > /dev/null 2>&1 &
+               local pids_r[$i]=$!
+       done
+       cancel_lru_locks osc
+
+       for ((i = 0; i < $n; i++)); do
+               wait ${pids_w[$i]}
+               wait ${pids_r[$i]}
+       done
+       rm -rf $dir || error "rm -rf $dir failed"
+}
+
+test_77a() { #LU-3266
+       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_policies="fifo"
+       nrs_write_read
+
+       return 0
+}
+run_test 77a "check FIFO NRS policy"
+
+
+test_77b() { #LU-3266
+       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_policies="crrn"
+       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_crrn_quantum=1
+
+       echo "policy: crr-n, crrn_quantum 1"
+       nrs_write_read
+
+       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_crrn_quantum=64
+
+       echo "policy: crr-n, crrn_quantum 64"
+       nrs_write_read
+
+       return 0
+}
+run_test 77b "check CRR-N NRS policy"
+
+orr_trr() {
+       local policy=$1
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies=$policy
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_"$policy"_quantum=1
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_"$policy"_offset_type="physical"
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_"$policy"_supported="reads"
+       done
+
+       echo "policy: $policy, ${policy}_quantum 1, ${policy}_offset_type \
+                               physical, ${policy}_supported reads"
+       nrs_write_read
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_${policy}_supported="writes"
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_${policy}_quantum=64
+       done
+       echo "policy: $policy, ${policy}_quantum 64, \
+               ${policy}_offset_type physical, ${policy}_supported writes"
+       nrs_write_read
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_${policy}_supported="reads_and_writes"
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_${policy}_offset_type="logical"
+       done
+       echo "policy: $policy, ${policy}_quantum 64, \
+               ${policy}_offset_type logical, ${policy}_supported reads_and_writes"
+       nrs_write_read
+
+       return 0
+}
+
+test_77c() { #LU-3266
+       orr_trr "orr"
+       return 0
+}
+run_test 77c "check ORR NRS policy"
+
+test_77d() { #LU-3266
+       orr_trr "trr"
+       return 0
+}
+run_test 77d "check TRR nrs policy"
+
+tbf_rule_operate()
+{
+       local facet=$1
+       shift 1
+
+       do_facet $facet lctl set_param \
+               ost.OSS.ost_io.nrs_tbf_rule="$@"
+       [ $? -ne 0 ] &&
+               error "failed to operate on TBF rules"
+}
+
+test_77e() {
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="tbf\ nid"
+               [ $? -ne 0 ] &&
+                       error "failed to set TBF policy"
+       done
+
+       # Only operate rules on ost0 since OSTs might run on the same OSS
+       # Add some rules
+       tbf_rule_operate ost0 "start\ localhost\ {0@lo}\ 1000"
+       local address=$(comma_list "$(host_nids_address $CLIENTS $NETTYPE)")
+       local client_nids=$(nids_list $address "\\")
+       tbf_rule_operate ost0 "start\ clients\ {$client_nids}\ 100"
+       tbf_rule_operate ost0 "start\ others\ {*.*.*.*@$NETTYPE}\ 50"
+       nrs_write_read
+
+       # Change the rules
+       tbf_rule_operate ost0 "change\ localhost\ 1001"
+       tbf_rule_operate ost0 "change\ clients\ 101"
+       tbf_rule_operate ost0 "change\ others\ 51"
+       nrs_write_read
+
+       # Stop the rules
+       tbf_rule_operate ost0 "stop\ localhost"
+       tbf_rule_operate ost0 "stop\ clients"
+       tbf_rule_operate ost0 "stop\ others"
+       nrs_write_read
+
+       # Cleanup the TBF policy
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+               [ $? -ne 0 ] &&
+                       error "failed to set policy back to fifo"
+       done
+       nrs_write_read
+       return 0
+}
+run_test 77e "check TBF NID nrs policy"
+
+test_77f() {
+       # Configure jobid_var
+       local saved_jobid_var=$($LCTL get_param -n jobid_var)
+       if [ $saved_jobid_var != procname_uid ]; then
+               set_conf_param_and_check client                 \
+                       "$LCTL get_param -n jobid_var"          \
+                       "$FSNAME.sys.jobid_var" procname_uid
+       fi
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="tbf\ jobid"
+               [ $? -ne 0 ] &&
+                       error "failed to set TBF policy"
+       done
+
+       # Only operate rules on ost0 since OSTs might run on the same OSS
+       # Add some rules
+       tbf_rule_operate ost0 "start\ runas\ {iozone.$RUNAS_ID\ dd.$RUNAS_ID\ tiotest.$RUNAS_ID}\ 1000"
+       tbf_rule_operate ost0 "start\ iozone_runas\ {iozone.$RUNAS_ID}\ 100"
+       tbf_rule_operate ost0 "start\ dd_runas\ {dd.$RUNAS_ID}\ 50"
+       nrs_write_read "$RUNAS"
+
+       # Change the rules
+       tbf_rule_operate ost0 "change\ runas\ 1001"
+       tbf_rule_operate ost0 "change\ iozone_runas\ 101"
+       tbf_rule_operate ost0 "change\ dd_runas\ 51"
+       nrs_write_read "$RUNAS"
+
+       # Stop the rules
+       tbf_rule_operate ost0 "stop\ runas"
+       tbf_rule_operate ost0 "stop\ iozone_runas"
+       tbf_rule_operate ost0 "stop\ dd_runas"
+       nrs_write_read "$RUNAS"
+
+       # Cleanup the TBF policy
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+               [ $? -ne 0 ] &&
+                       error "failed to set policy back to fifo"
+       done
+       nrs_write_read "$RUNAS"
+
+       local current_jobid_var=$($LCTL get_param -n jobid_var)
+       if [ $saved_jobid_var != $current_jobid_var ]; then
+               set_conf_param_and_check client                 \
+                       "$LCTL get_param -n jobid_var"          \
+                       "$FSNAME.sys.jobid_var" $saved_jobid_var
+       fi
+       return 0
+}
+run_test 77f "check TBF JobID nrs policy"
+
+test_77g() {
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="tbf\ nid"
+               [ $? -ne 0 ] &&
+                       error "failed to set TBF policy"
+       done
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="tbf\ jobid"
+               [ $? -ne 0 ] &&
+                       error "failed to set TBF policy"
+       done
+
+       # Add a rule that only valid for Jobid TBF. If direct change between
+       # TBF types is not supported, this operation will fail.
+       tbf_rule_operate ost0 "start\ dd_runas\ {dd.$RUNAS_ID}\ 50"
+
+       # Cleanup the TBF policy
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+               [ $? -ne 0 ] &&
+                       error "failed to set policy back to fifo"
+       done
+       return 0
+}
+run_test 77g "Change TBF type directly"
+
+test_80() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local MDTIDX=1
+       local mdt_index
+       local i
+       local file
+       local pid
+
+       mkdir -p $DIR1/$tdir/dir
+       createmany -o $DIR1/$tdir/dir/f 10 ||
+               error "create files under remote dir failed $i"
+
+       cp /etc/passwd $DIR1/$tdir/$tfile
+
+       #migrate open file should fails
+       multiop_bg_pause $DIR2/$tdir/$tfile O_c || error "open $file failed"
+       pid=$!
+       # give multiop a chance to open
+       sleep 1
+
+       $LFS migrate -m $MDTIDX $DIR1/$tdir &&
+               error "migrate open files should failed with open files"
+
+       kill -USR1 $pid
+
+       $LFS migrate -m $MDTIDX $DIR1/$tdir ||
+                       error "migrate remote dir error"
+
+       echo "Finish migration, then checking.."
+       for file in $(find $DIR1/$tdir); do
+               mdt_index=$($LFS getstripe -M $file)
+               [ $mdt_index == $MDTIDX ] ||
+                       error "$file is not on MDT${MDTIDX}"
+       done
+
+       diff /etc/passwd $DIR1/$tdir/$tfile ||
+               error "file different after migration"
+
+       rm -rf $DIR1/$tdir || error "rm dir failed after migration"
+}
+run_test 80 "migrate directory when some children is being opened"
+
+test_81() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       rm -rf $DIR1/$tdir
+
+       mkdir -p $DIR1/$tdir
+
+       $LFS setdirstripe -i0 -c$MDSCOUNT  $DIR1/$tdir/d0
+       $LFS setdirstripe -i0 -c$MDSCOUNT  $DIR1/$tdir/d1
+
+       cd $DIR1/$tdir
+       touch d0/0      || error "create 0 failed"
+       mv d0/0 d1/0    || error "rename d0/0 d1/0 failed"
+       stat d0/0       && error "stat mv filed succeed"
+       mv $DIR2/$tdir/d1/0 $DIR2/$tdir/d0/0 || "rename d1/0 d0/0 failed"
+       stat d0/0       || error "stat failed"
+
+       local t=$(ls -ai $DIR1/$tdir/d0 | sort -u | wc -l)
+
+       if [ $t -ne 3 ]; then
+               ls -ai $DIR1/$tdir/d0
+               error "expect 3 get $t"
+       fi
+
+       return 0
+}
+run_test 81 "rename and stat under striped directory"
+
+test_82() {
+       [[ $(lustre_version_code $SINGLEMDS) -gt $(version_code 2.6.91) ]] ||
+               { skip "Need MDS version at least 2.6.92"; return 0; }
+
+       # Client 1 creates a file.
+       multiop_bg_pause $DIR1/$tfile O_ac || error "multiop_bg_pause 1"
+       pid1=$!
+       # Client 2 opens the file.
+       multiop_bg_pause $DIR2/$tfile o_Ac || error "multiop_bg_pause 2"
+       pid2=$!
+       # Client 1 makes the file an orphan.
+       rm $DIR1/$tfile || error "rm"
+       # Client 2 sets EA "user.multiop".
+       kill -s USR1 $pid2
+       wait $pid2 || error "multiop 2"
+       # Client 1 gets EA "user.multiop".  This used to fail because the EA
+       # cache refill would get "trusted.link" from mdd_xattr_list() but
+       # -ENOENT when trying to get "trusted.link"'s value.  See also sanity
+       # 102q.
+       kill -s USR1 $pid1
+       wait $pid1 || error "multiop 1"
+}
+run_test 82 "fsetxattr and fgetxattr on orphan files"
+
+test_83() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local pid1
+       local pid2
+
+       (
+               cd $DIR1
+               while true; do
+                       $LFS mkdir -i1 -c2 $tdir
+                       rmdir $tdir
+               done
+       ) &
+       pid1=$!
+       echo "start pid $pid1 to create/unlink striped directory"
+
+       # Access the directory at the same time
+       (
+               cd $DIR2
+               while true; do
+                       stat $tdir > /dev/null 2>&1
+               done
+       ) &
+       pid2=$!
+       echo "start pid $pid2 to stat striped directory"
+
+       sleep 120
+       kill $pid1 $pid2
+       wait $pid1 $pid2
+
+       return 0
+}
+run_test 83 "access striped directory while it is being created/unlinked"
+
 log "cleanup: ======================================================"
 
 [ "$(mount | grep $MOUNT2)" ] && umount $MOUNT2
 
 complete $SECONDS
+rm -f $SAMPLE_FILE
 check_and_cleanup_lustre
 exit_status